/* gcd.cpp implementation of the gcd library for computing the
 *  greatest common divisor.
 *
 * Author: Joel C. Adams, for Hands On C++.
 * Modification history:
 *   by Jeremy D. Frens in January 2003 for Hands on C++, 3e.
 *     Created gcd library.
 ******************************************************************/

#include <cstdlib>  // abs()
using namespace std;

int greatestCommonDivisor(int alpha, int beta)
{
  alpha = abs(alpha);
  beta = abs(beta);

  if (beta == 0)       // base case
    return alpha;
  else                 // induction step
    {
      int remainder = alpha % beta;
      return greatestCommonDivisor(beta, remainder);
    }
}
